<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\Dispositivo;
use App\DataTables\DispositivoDataTable;
use App\DataTables\DispositivoDataTableEditor;
use Illuminate\Support\Facades\Auth;


class DispositivoController extends Controller
{
    public static $permission_group = "Dispositivi";
    public static $permissions = [
        'view-dispositivo' => 'Vedi',
        'create-dispositivo' => 'Crea',
        'edit-dispositivo' => 'Modifica',
        'delete-dispositivo' => 'Elimina',
    ];
    
    public static function middleware(): array
    {
        return [
            new Middleware('permission:view-dispositivo', only: ['index']),
            new Middleware('permission:create-dispositivo|edit-dispositivo|delete-dispositivo', only: ['store', 'update', 'destroy']),
        ];
    }
    
    public function index(DispositivoDataTable $dataTable)
    {
        return $dataTable->render('dispositivo.index');
    }
    public function store(DispositivoDataTableEditor $editor)
    {
        $request = request();
        $input = $request->all();
        if($request->has('action')){
            switch($input['action']){
                case 'create':
                    if(!Auth::user()->can('create-dispositivo')) return;
                    break;
                case 'edit':
                    if(!Auth::user()->can('edit-dispositivo')) return;
                    break;
                case 'remove':
                    if(!Auth::user()->can('delete-dispositivo')) return;
                    break;
            }
        }
        return $editor->process($request);
    }
}
